<template>
  <slot v-if="load" />
</template>

<script>
export const opts = {
  src: {
    type: [String, Array],
    required: true
  }
}
</script>

<script setup>
import { inject, ref, computed, watch, onBeforeUnmount } from 'vue'
import { eventsImageEmit } from './shared/events.js'

// inject
const map = inject('map')

// events
const emit = defineEmits(eventsImageEmit)

// props
const props = defineProps(opts)

// data
const load = ref(false)

// computed
const isString = computed(() => {
  return typeof props.src === 'string'
})

// load image Promise
const loadImage = url => {
  return new Promise((resolve, reject) => {
    const hasImage = map.value.hasImage(url)
    if (hasImage) resolve()
    map.value.loadImage(url, (error, image) => {
      if (error) reject(error)
      map.value.addImage(url, image)
      emit('load', image)
      resolve()
    })
  })
}

// load an array of images
const loadArray = urls => {
  const images = urls.map(url => loadImage(url))
  return Promise.all(images)
}

// success calback
const succes = () => {
  load.value = true
  emit('mounted')
}

// error calback
const error = err => emit('error', err)

// load
const init = () => {
  if (isString.value) {
    loadImage(props.src)
      .then(succes)
      .catch(error)
  } else {
    loadArray(props.src)
      .then(succes)
      .catch(error)
  }
}

// remove images
const remove = () => {
  if (isString.value && map.value.hasImage(props.src)) {
    map.value.removeImage(props.src)
  } else {
    for (const url of props.src) {
      if (map.value.hasImage(url)) {
        map.value.removeImage(url)
      }
    }
  }
}

// remove and readd
const reset = () => {
  load.value = false
  remove()
  init()
}

// mount
init()

// watch
watch(() => props.src, reset)

// clean
// onBeforeUnmount(remove)
</script>
